/**
 * @file
 * Configured theme header for all screen widths.
 */

(function ($, Drupal) {
  Drupal.behaviors.sshopAnchorScroll = {
    attach: (context) => {
      // Main navigation.
      const menuBreakPoint = 768;
      const $headerElements = [
        'header .site-branding',
        'header .navbar-collapse',
      ];
      const $header = $('header.navbar');
      const $mainNav = $('.main-navigation', $header);
      const $mainNavUl = $('.navbar-nav', $mainNav);
      const $menuToggleIcon = $('.menu-toggle', $header);
      const $mainNavMore = $(
        '<li class="nav-more menu-item-has-children"><a href="#">' +
          '<i class="fa fa-ellipsis-h"></i></a>' +
          '<ul style="max-height: 99999px; visibility: visible"' +
          ' class="sub-filters dropdown-menu"></ul>' +
          '</li>',
      );

      $mainNav.find('.navbar-nav.menu').append($mainNavMore);

      const setupHeader = function () {
        const ww = $(window).width();
        const hw = $header.width();
        let _w = 0;

        $('> ul > li', $mainNavMore).each(function () {
          $mainNavUl.append($(this));
        });

        if (ww < menuBreakPoint) {
          $mainNavMore.hide();
          return false;
        }

        const moreWidth = $mainNavMore.outerWidth();
        $.each($headerElements, function (index, id) {
          const $el = $(id);
          _w += $el.outerWidth();
        });

        const navWidth = hw - _w - 60;

        let w = moreWidth;
        $('> li', $mainNavUl)
          .not('.nav-more')
          .each(function () {
            const width = $(this).outerWidth();
            if (navWidth < w + width) {
              const $li = $(this);
              $mainNavMore.find('.sub-filters').append($li);
            }
            w += width;
          });

        $mainNavUl.append($mainNavMore);
        $mainNav.removeClass('no-js');
        if ($('> ul > li', $mainNavMore).length > 0) {
          $mainNavMore.show();
        } else {
          $mainNavMore.hide();
        }
      };

      // Setup header.
      setupHeader();

      $(window).on('resize', function () {
        setupHeader();
      });

      // Menu-mobile.
      $menuToggleIcon.on('click', function (e) {
        e.preventDefault();
        $mainNavUl.toggleClass('menu-open');
      });
    },
  };
})(jQuery, Drupal);
